Video for Linux Two API Specification: Revision 0.24
Prev |  | Next

# ioctl VIDIOC_STREAMON, VIDIOC_STREAMOFF

## Name

VIDIOC_STREAMON, VIDIOC_STREAMOFF -- Start or stop streaming I/O

## Synopsis

``int ioctl`(int fd, int request, const int *argp);`

## Arguments

`fd`

  File descriptor returned by `open()`.

`request`

  VIDIOC_STREAMON, VIDIOC_STREAMOFF

`argp`

## Description

The `VIDIOC_STREAMON` and `VIDIOC_STREAMOFF` ioctl start and stop the capture or output process during streaming (memory mapping or user pointer) I/O.

Specifically the capture hardware is disabled and no input buffers are filled (if there are any empty buffers in the incoming queue) until `VIDIOC_STREAMON` has been called. Accordingly the output hardware is disabled, no video signal is produced until `VIDIOC_STREAMON` has been called. The ioctl will succeed only when at least one output buffer is in the incoming queue.

The `VIDIOC_STREAMOFF` ioctl, apart of aborting or finishing any DMA in progress, unlocks any user pointer buffers locked in physical memory, and it removes all buffers from the incoming and outgoing queues. That means all images captured but not dequeued yet will be lost, likewise all images enqueued for output but not transmitted yet. I/O returns to the same state as after calling `VIDIOC_REQBUFS` and can be restarted accordingly.

Both ioctls take a pointer to an integer, the desired buffer or stream type. This is the same as struct v4l2_requestbuffers `type`.

Note applications can be preempted for unknown periods right before or after the `VIDIOC_STREAMON` or `VIDIOC_STREAMOFF` calls, there is no notion of starting or stopping "now". Buffer timestamps can be used to synchronize with other events.

## Return Value

On success 0 is returned, on error -1 and the `errno` variable is set appropriately:

EINVAL

  Streaming I/O is not supported, the buffer `type` is not supported, or no buffers have been allocated (memory mapping) or enqueued (output) yet.

Prev | Home | Next
ioctl VIDIOC_REQBUFS | Up | V4L2 mmap()